// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcgcd_spl_14:msg/TeamInfo.idl
// generated code does not contain a copyright notice
#include "rcgcd_spl_14/msg/detail/team_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `players`
#include "rcgcd_spl_14/msg/detail/robot_info__functions.h"

bool
rcgcd_spl_14__msg__TeamInfo__init(rcgcd_spl_14__msg__TeamInfo * msg)
{
  if (!msg) {
    return false;
  }
  // team_number
  // team_colour
  // score
  // penalty_shot
  // single_shots
  // message_budget
  // players
  for (size_t i = 0; i < 7; ++i) {
    if (!rcgcd_spl_14__msg__RobotInfo__init(&msg->players[i])) {
      rcgcd_spl_14__msg__TeamInfo__fini(msg);
      return false;
    }
  }
  return true;
}

void
rcgcd_spl_14__msg__TeamInfo__fini(rcgcd_spl_14__msg__TeamInfo * msg)
{
  if (!msg) {
    return;
  }
  // team_number
  // team_colour
  // score
  // penalty_shot
  // single_shots
  // message_budget
  // players
  for (size_t i = 0; i < 7; ++i) {
    rcgcd_spl_14__msg__RobotInfo__fini(&msg->players[i]);
  }
}

rcgcd_spl_14__msg__TeamInfo *
rcgcd_spl_14__msg__TeamInfo__create()
{
  rcgcd_spl_14__msg__TeamInfo * msg = (rcgcd_spl_14__msg__TeamInfo *)malloc(sizeof(rcgcd_spl_14__msg__TeamInfo));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcgcd_spl_14__msg__TeamInfo));
  bool success = rcgcd_spl_14__msg__TeamInfo__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rcgcd_spl_14__msg__TeamInfo__destroy(rcgcd_spl_14__msg__TeamInfo * msg)
{
  if (msg) {
    rcgcd_spl_14__msg__TeamInfo__fini(msg);
  }
  free(msg);
}


bool
rcgcd_spl_14__msg__TeamInfo__Sequence__init(rcgcd_spl_14__msg__TeamInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcgcd_spl_14__msg__TeamInfo * data = NULL;
  if (size) {
    data = (rcgcd_spl_14__msg__TeamInfo *)calloc(size, sizeof(rcgcd_spl_14__msg__TeamInfo));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcgcd_spl_14__msg__TeamInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcgcd_spl_14__msg__TeamInfo__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcgcd_spl_14__msg__TeamInfo__Sequence__fini(rcgcd_spl_14__msg__TeamInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcgcd_spl_14__msg__TeamInfo__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcgcd_spl_14__msg__TeamInfo__Sequence *
rcgcd_spl_14__msg__TeamInfo__Sequence__create(size_t size)
{
  rcgcd_spl_14__msg__TeamInfo__Sequence * array = (rcgcd_spl_14__msg__TeamInfo__Sequence *)malloc(sizeof(rcgcd_spl_14__msg__TeamInfo__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rcgcd_spl_14__msg__TeamInfo__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rcgcd_spl_14__msg__TeamInfo__Sequence__destroy(rcgcd_spl_14__msg__TeamInfo__Sequence * array)
{
  if (array) {
    rcgcd_spl_14__msg__TeamInfo__Sequence__fini(array);
  }
  free(array);
}
